#include <stdio.h>
#include <malloc.h>
#include "list.h"

/*
struct list
{
    int      id;
    Element* where;
    Element* first;
};
*/

List* listcreate(n)
    int n;
{
    List* l = (List*)malloc(sizeof(List));
    if (l == NULL)
    {
        fprintf(stderr,"listcreate: malloc failed, out of memory???\n");
        return NULL;
    }
    l->id = n;
    l->where = NULL;
    l->first = NULL;
    return l;
}

void listinit(l)
    List* l;
{
    if (l == NULL) return;
    l->id = -1;
    l->where = NULL;
    l->first = NULL;
}

int listid(head)
    List* head;
{
    if (head == NULL) return 0;
    return head->id;
}

Element* listfirst(head)
    List* head;
{
    if (head == NULL) return NULL;
    head->where = head->first;
    return head->where;
}

void listinsert(l,e)
    List* l;
    Element* e;
{
    if (l == NULL) return;
    if (e == NULL) return;
    elementsetnext(e,l->first);
    l->first = e;
}

Element* listnext(l)
    List *l;
{
    if (l == NULL) return NULL;
    if (l->where == NULL) return NULL;
    l->where = elementnext(l->where);
    return l->where;
}

